SystemOrganization addCategory: #'Volunti-GenerationServers-Model'!
SystemOrganization addCategory: #'Volunti-GenerationServers-View'!

WAComponent subclass: #VOKeyPairsManagementComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-GenerationServers-View'!

!VOKeyPairsManagementComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 13:49'!
renderActionsOn: html
	html anchor
		class: 'btn btn-success';
		callback: [ self session agent generateKeyPairs ];
		with: 'Generate key pairs'.
	html space.
	html anchor
		class: 'btn btn-danger';
		callback: [ self session agent clearKeyPairs ];
		with: 'Clear key pairs'! !

!VOKeyPairsManagementComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 13:49'!
renderContentOn: html
	self renderInformationOn: html.
	self renderActionsOn: html! !

!VOKeyPairsManagementComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 13:49'!
renderInformationOn: html
	html
		paragraph: [ 
			html
				strong: self session agent numberOfKeyPairs;
				text: ' key pairs are available.' ]! !

VOAgentComponent subclass: #VOIDGenerationServerComponent
	instanceVariableNames: 'idgsLog kgsLog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-GenerationServers-View'!

!VOIDGenerationServerComponent class methodsFor: 'class initialization' stamp: 'NicolasVanderAuwera 12/16/2012 09:58'!
initialize
	self register! !

!VOIDGenerationServerComponent class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/2/2012 13:33'!
url
	^ 'idgeneration'! !

!VOIDGenerationServerComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/2/2012 13:37'!
agentClass
	^ VOIDGenerationServer! !

!VOIDGenerationServerComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/2/2012 13:41'!
title
	^ 'ID Generation Server'! !

VOAgentComponent subclass: #VOKeyGenerationServerComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-GenerationServers-View'!

!VOKeyGenerationServerComponent class methodsFor: 'class initialization' stamp: 'NicolasVanderAuwera 12/16/2012 09:58'!
initialize
	self register! !

!VOKeyGenerationServerComponent class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/2/2012 13:33'!
url
	^ 'keygeneration'! !

!VOKeyGenerationServerComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/2/2012 13:40'!
agentClass
	^ VOKeyGenerationServer! !

!VOKeyGenerationServerComponent methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/20/2012 13:41'!
buildAdministration
	^ VOKGSAdministrationComponent new! !

!VOKeyGenerationServerComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/2/2012 13:42'!
title
	^ 'Key Generation Server'! !

VOAdministrationComponent subclass: #VOKGSAdministrationComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-GenerationServers-View'!

!VOKGSAdministrationComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2012 13:39'!
components
	^ super components
		at: 'Key pairs management' put: VOKeyPairsManagementComponent new;
		yourself! !

VOCertifiedAgent subclass: #VOIDGenerationServer
	instanceVariableNames: 'ids'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-GenerationServers-Model'!

VOIDGenerationServer class
	instanceVariableNames: 'ids'!

VOIDGenerationServer class
	instanceVariableNames: 'ids'!

!VOIDGenerationServer class methodsFor: 'generator' stamp: 'NicolasVanderAuwera 5/3/2012 16:19'!
generateID
	| id |
	[ 
	id := SecureRandom new nextFrom: 10000 to: 1000000.
	self ids includes: id ] whileTrue.
	self ids add: id.
	^ id! !

!VOIDGenerationServer class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 16:17'!
ids
	ids isNil
		ifTrue: [ ids := SortedCollection new ].
	^ ids! !

!VOIDGenerationServer class methodsFor: 'x509' stamp: 'NicolasVanderAuwera 5/5/2012 15:56'!
organisationUnit
	^ 'ID Generator'! !

!VOIDGenerationServer class methodsFor: 'network' stamp: 'NicolasVanderAuwera 5/3/2012 16:19'!
port
	^ 3278! !

!VOIDGenerationServer methodsFor: 'network' stamp: 'NicolasVanderAuwera 5/5/2012 16:13'!
handle: aSymbol
	super handle: aSymbol.
	aSymbol = #id
		ifFalse: [ ^ self ].
	self sendID! !

!VOIDGenerationServer methodsFor: 'network' stamp: 'NicolasVanderAuwera 8/22/2012 08:02'!
sendID
	stream sendCommand: self class generateID.
	self addInLog: 'A new identifier has been send.'! !

VOCertifiedAgent subclass: #VOKeyGenerationServer
	instanceVariableNames: 'p q keyPairs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-GenerationServers-Model'!

!VOKeyGenerationServer commentStamp: 'NicolasVanderAuwera 3/10/2012 15:53' prior: 0!
I generate RSA key pair based on the same modulo.!

!VOKeyGenerationServer class methodsFor: 'x509' stamp: 'NicolasVanderAuwera 5/5/2012 15:56'!
organisationUnit
	^ 'Key Generator'! !

!VOKeyGenerationServer class methodsFor: 'network' stamp: 'NicolasVanderAuwera 2/14/2012 12:49'!
port
	^ 7777! !

!VOKeyGenerationServer methodsFor: 'testing' stamp: 'NicolasVanderAuwera 5/3/2012 16:07'!
checkKeyPairs
	self keyPairs isEmpty
		ifTrue: [ self generateKeyPairs ]! !

!VOKeyGenerationServer methodsFor: 'actions' stamp: 'NicolasVanderAuwera 11/20/2012 13:47'!
clearKeyPairs
	keyPairs := OrderedCollection new! !

!VOKeyGenerationServer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/18/2012 10:05'!
defaultNumberOfKeyPairs
	^ 50! !

!VOKeyGenerationServer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/5/2012 14:19'!
firstKeyPair
	^ self keyPairs removeFirst! !

!VOKeyGenerationServer methodsFor: 'actions' stamp: 'NicolasVanderAuwera 11/20/2012 13:47'!
generateKeyPair
	| gen |
	gen := VORSAKeyPairGenerator new
		bits: CryptographicParameters rsaKeyLength;
		p: p;
		q: q;
		yourself.
	^ Dictionary new
		at: #publickey put: gen publicKey;
		at: #privatekey put: gen privateKey;
		yourself! !

!VOKeyGenerationServer methodsFor: 'actions' stamp: 'NicolasVanderAuwera 8/22/2012 08:11'!
generateKeyPairs
	self defaultNumberOfKeyPairs timesRepeat: [ self keyPairs add: self generateKeyPair ].
	self addInLog: self defaultNumberOfKeyPairs greaseString , ' key pairs have been generated.'! !

!VOKeyGenerationServer methodsFor: 'network' stamp: 'NicolasVanderAuwera 11/20/2012 13:24'!
handle: aMessage
	super handle: aMessage.
	aMessage command = #keys
		ifTrue: [ self sendKeys ]! !

!VOKeyGenerationServer methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/1/2012 14:15'!
initialize
	| gen |
	super initialize.
	gen := VORSAKeyPairGenerator new bits: CryptographicParameters rsaKeyLength.
	p := gen p.
	q := gen q.
	self generateKeyPairs! !

!VOKeyGenerationServer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2012 13:47'!
keyPairs
	^ keyPairs ifNil: [ self clearKeyPairs ]! !

!VOKeyGenerationServer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/22/2012 08:07'!
numberOfKeyPairs
	^ self keyPairs size! !

!VOKeyGenerationServer methodsFor: 'network' stamp: 'NicolasVanderAuwera 11/20/2012 13:31'!
sendKeys
	stream sendObject: self firstKeyPair.
	self addInLog: 'A key pair has been send. It remains ' , self numberOfKeyPairs greaseString , ' key pairs'! !

!VOKeyGenerationServer methodsFor: 'running' stamp: 'NicolasVanderAuwera 5/3/2012 16:07'!
start
	self checkKeyPairs.
	super start! !
VOIDGenerationServerComponent initialize!
VOKeyGenerationServerComponent initialize!
